//---------------------------------------------------------------------------
//
//   TransMorphOther
//
//          Copyright(C) 2015, Tark
//
//	قȂ\̃IuWFNgփ[tRs[vOC
//	NFIuWFNgplŃRs[ƃRs[̃x[XIuWFNgw肷
//	ʁFό`Kpe[tIuWFNǧɕό`KpIuWFNg}
//
//---------------------------------------------------------------------------

//#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "MQPlugin.h"
#include "MQBasePlugin.h"
#if MQPLUGIN_VERSION >= 0x0400
#include "MQ3DLib.h"
#include "MQWidget.h"
#endif

#include <math.h>
#include <vector>
#include <unordered_map>
#include <set>
#include <memory>
#include <sstream>
#include <algorithm>

#include "TransMorphOtherWindow.h"
#include "TransMorphOther.h"

#if MQPLUGIN_VERSION < 0x0400
HINSTANCE hInstance;
#endif

//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
#if MQPLUGIN_VERSION < 0x0400
	//_CAO{bNX̕\ɕKvȂ̂ŁACX^XۑĂ
	hInstance = (HINSTANCE)hModule;
#endif

	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
	return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
void TransMorphOther::GetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0xE3F7A830;
	*ID = 0xBD9A1886;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
const char *TransMorphOther::GetPlugInName(void)
{
	// vOC
	return "TransMorphOther v.1.0 Copyright(C) 2015, Tark.";
}

//---------------------------------------------------------------------------
//  MQEnumString
//    |bvAbvj[ɕ\镶ԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
const char *TransMorphOther::EnumString(int index)
{
	switch(index){
	case 0: return "TransMorphOther";
	}
	return nullptr;
}

MQBasePlugin *GetPluginClass()
{
	static TransMorphOther plugin;
	return &plugin;
}

BOOL TransMorphOther::Execute(int index, MQDocument doc_)
{
	switch(index){
	case 0:
		{
			doc = doc_;
			return main();
		}
	}
	return FALSE;
}

// staticIuWFNg
TransMorphOther::TransMorphSetting TransMorphOther::transMorphSetting; // _CAOݒl

/*
	C[`
*/
BOOL TransMorphOther::main()
{
	// IuWFNgplőIIuWFNg擾
	if (!getSelectedObjectList()) {
		return FALSE;
	}
	// objsrcɑ΂郂[tIuWFNg𒊏o
	getMorphObjects();
	// ݒ_CAO\
	callDialog();
	if(!transMorphSetting.going) {
		return TRUE;
	}
	// _CAÕ[tIuWFNgIʂvecobjmorph쐬
	createMorphlist();
	// f̃[tIuWFNg쐬
	addNewMorph();
	// ߋ_}bv쐬
	makeVertexmap();
	// [tf
	transMorph();
	// obNAbv폜
	//deleteBackupObj();

	return TRUE;
}

/*
	IuWFNgplőIIuWFNg擾
*/
BOOL TransMorphOther::getSelectedObjectList()
{
	int selected_count = 0;
	for(int i = 0; i < doc.getObjectCount(); i++) {
		cmq::CMQObject obj = doc.getObject(i);
		if(!obj.isLive()) {continue;}
		if(obj.getSelected()) {
			if(selected_count == 0) {objsrc = obj;}
			else if(selected_count == 1) {objdst = obj;}
			else {break;}
			selected_count++;
		}
	}
	if(selected_count < 2) {
		return FALSE;
	}
	transMorphSetting.srcname = objsrc.getName();
	transMorphSetting.dstname = objdst.getName();
	return TRUE;
}

/*
	objsrcɑ΂郂[tIuWFNg𒊏oA_CAÕXgɏo߂morphlistɓ
*/
BOOL TransMorphOther::getMorphObjects()
{
	transMorphSetting.morphlist.clear();
	// srcIuWFNg̖O
	std::string name = getObjectMainName(objsrc.getName());
	int vcount = objsrc.getVertexCount();
	// [tIuWFNg
	for(int i = 0; i < doc.getObjectCount(); i++) {
		cmq::CMQObject obj = doc.getObject(i);
		if(!obj.isLive()) {continue;}
		if(obj == objsrc || obj == objdst) {continue;}
		std::string morphname = obj.getName();
		if(isMorphObject(name, morphname)) {
			transMorphSetting.morphlist.push_back(std::make_pair(obj, obj.getLocking() == FALSE));
		}
	}
	if(transMorphSetting.morphlist.size() == 0) {
		return FALSE;
	}
	return TRUE;
}

/*
	orignameIuWFNg𔲂o"`:(*)-`"
*/
std::string TransMorphOther::getObjectMainName(const std::string &origname)
{
	std::string name(origname);
	std::string::size_type pos;
	if((pos = name.find(':')) != std::string::npos) {
		name = name.substr(pos + 1);
	}
	if((pos = name.find('-')) != std::string::npos && pos > 1) {
		name = name.substr(0, pos);
	}
	return name;
}

/*
	morphobjnameobjnameɑ΂郂[ť`"elem:*-(*)"ł邩ۂ
*/
bool TransMorphOther::isMorphObject(const std::string &objname, const std::string &morphobjname)
{
	if(morphobjname.substr(0, 5) != "elem:") {
		return false;
	}
	std::string::size_type pos;
	if((pos = morphobjname.find('-')) != std::string::npos) {
		if(objname == morphobjname.substr(pos + 1)) {
			return true;
		}
	}
	return false;
}

/*
	_CAÕ[tIuWFNgIʂvecobjmorph쐬
*/
void TransMorphOther::createMorphlist()
{
	for(std::pair<cmq::CMQObject, bool> &p : transMorphSetting.morphlist) {
		if(p.second) {
			vecobjmorph.push_back(p.first);
		}
	}
	transMorphSetting.morphlist.clear();
}

int findObj(cmq::CMQDocument &doc, const std::string &name) {
	cmq::oindex_t ocount = doc.getObjectCount();
	for (cmq::oindex_t oindex = 0; oindex < ocount; oindex++) {
		cmq::CMQObject obj = doc.getObject(oindex);
		if (obj.isLive() && obj.getName() == name) {
			return oindex;
		}
	}
	return -1;
}

/*
	[tIuWFNgpobjdst̃N[쐬Ēǉ
*/
BOOL TransMorphOther::addNewMorph()
{
	// f惂[t쐬
	std::string destobjname = objdst.getName();
	for (cmq::CMQObject &obj : vecobjmorph) {
		//[tIuWFNg𕡐
		cmq::CMQObject newmorph =  objdst.clone();
		std::string srcelemname = obj.getName();
		std::string::size_type pos;
		if((pos = srcelemname.find('-')) == std::string::npos) {
			// IuWFNgGǧ`ł͂Ȃ
			pos = srcelemname.length();
		}
		std::string morphname = srcelemname.substr(0, pos);
		std::string newname = morphname + '-' + destobjname;
		newmorph.setName(newname);

		vecobjnewmorph.push_back(newmorph);
		cmq::oindex_t oindex = -1;
		if ((oindex = findObj(doc, newname)) >= 0) {
			cmq::CMQObject findobj = doc.getObject(oindex);
			if (transMorphSetting.backup) {
				//[tobj擪#tOɂ(unused nameɂ)
				findobj.setName(doc.getUnusedName("#" + newname).c_str());
			}
			else {
				// [t͍폜
				doc.deleteObject(findobj);
			}
		}
		doc.insertObject(newmorph, obj);
	}
	return TRUE;
}

// ߋ_Ȃ}
void insertnear(std::vector<std::pair<cmq::vindex_t, float>> &nearvertex, const std::pair<cmq::vindex_t, float> &vpair)
{
	const int MAXSIZE = 3;
	bool inserted = false;
	for (auto it = nearvertex.rbegin(); it != nearvertex.rend(); ++it) {
		float d = it->second;
		if (d < vpair.second) {
			if (nearvertex.size() == MAXSIZE && it == nearvertex.rbegin()) {
				return;
			}
			nearvertex.insert(it.base(), vpair);
			inserted = true;
			break;
		}
	}
	if (!inserted) {
		nearvertex.insert(nearvertex.begin(), vpair);
	}
	if (nearvertex.size() > MAXSIZE) {
		nearvertex.resize(MAXSIZE);
	}
}

/*
ߐڋ̒_Ή}bv쐬
*/
BOOL TransMorphOther::makeVertexmap()
{
	// e_ɂāAsrcobj̍ł߂_3܂Ō
	cmq::CMQContainer<cmq::CMQVertex, cmq::CMQObject> vdcontainer(&objdst);
	for (auto vdit = vdcontainer.begin(); vdit != vdcontainer.end(); ++vdit) {
		if (transMorphSetting.selected_vertex_only && !objdst.isSelectVertex(vdit.index())) {
			// I𒸓_݂̂̂Ƃ͔I𒸓_̓XLbv
			continue;
		}
		MQPoint dpos = objdst.getVertex(vdit.index());
		cmq::CMQContainer<cmq::CMQVertex, cmq::CMQObject> vscontainer(&objsrc);
		std::vector<std::pair<cmq::vindex_t, float>> nearvertex; // ߋ_i[
		for (auto vsit = vscontainer.begin(); vsit != vscontainer.end(); ++vsit) {
			MQPoint spos = objsrc.getVertex(vsit.index());
			float distance = (dpos - spos).norm(); // ̓
			auto vpair = std::make_pair(vsit.index(), distance);
			insertnear(nearvertex, vpair);
		}
		vecmap.insert(std::make_pair(vdit.index(), nearvertex));
	}
	return TRUE;
}

/*
	objdstpɍ쐬e[tɁAobjsrc̊e[t̕ό`x𔽉f
*/
BOOL TransMorphOther::transMorph()
{
	std::unordered_map<int, int> addvertexgrp; // ǉ_ԍǉ_O[vԍ
	int addvertexgrpnumber = 0;
	std::unordered_map<int, std::set<int> > neighborvertex; // ǉ_O[vאڊ_ԍZbg
	std::unordered_map<cmq::vindex_t, cmq::vindex_t> vindex_map; // destsrc_Ή}bv

	for(int vindex = 0; vindex < objdst.getVertexCount(); vindex++) {
		if(objdst.getVertexRefCount(vindex) == 0) {
			// L_łȂ
			continue;
		}
		if(transMorphSetting.selected_vertex_only && !doc.isSelectVertex(objdst, vindex)) {
			// I𒸓_݂̂̏ꍇAI𒸓_ȊO̓XLbv
			continue;
		}
		auto findit = vecmap.find(vindex);
		if (findit == vecmap.end()) {
			continue;
		}
		auto nearvertex = findit->second;
		auto itsrc = vecobjmorph.begin(); // fO[tIuWFNg̃Ce[^
		auto itdst = vecobjnewmorph.begin(); // fヂ[tIuWFNg̃Ce[^
		for (; itsrc != vecobjmorph.end(); itsrc++, itdst++) {
			// _[t]
			MQPoint morphing = IDW(vindex, nearvertex, *itsrc);
			MQPoint posdst = itdst->getVertex(vindex);
			posdst += morphing;
			itdst->setVertex(vindex, posdst);
		}
	}

	return TRUE;
}

/*
	Inverse Distance Weighting
	idw(x)=sum(u(i)w(i))/sum(w(j))
	w(k)=1/pow(d(k),p)
*/
MQPoint TransMorphOther::IDW(int vindex, std::vector<std::pair<cmq::vindex_t, float>> &nearvertex, cmq::CMQObject &morphobj)
{
	MQPoint sum(0, 0, 0);
	MQPoint v = objdst.getVertex(vindex);
	MQPoint u(0, 0, 0);
	float d = 0.0f;
	for (auto vpair : nearvertex) {
		cmq::vindex_t vindexsrc = vpair.first;
		float distance = vpair.second;
		if (distance == 0.0) {
			// ߖTł͂Ȃn_̒_ꍇ͂̃[tl̂̂gp
			MQPoint m = morphobj.getVertex(vindexsrc) - objsrc.getVertex(vindexsrc);
			return m;
		}
		float w = 1.0f / distance; // p = 2.0
		d += w;
		// morph
		MQPoint m = morphobj.getVertex(vindexsrc) - objsrc.getVertex(vindexsrc);
		u += m * w;
	}
	return d == 0.0f ? u : u / d;
}

BOOL TransMorphOther::callDialog()
{
	MQWindow mainwin = MQWindow::GetMainWindow();
	TransMorphOtherWindow dlg(mainwin, this);
	if(dlg.Execute() != MQDialog::DIALOG_OK){
		return FALSE;
	}
	char **p = nullptr;

	int count = dlg.list->GetItemCount();
	for(int i = 0; i < count; i++) {
		transMorphSetting.morphlist[i].second = dlg.list->GetItemSelected(i);
	}
	transMorphSetting.selected_vertex_only = dlg.check_selvert->GetChecked();
	transMorphSetting.backup = dlg.check_backup->GetChecked();

	transMorphSetting.going = true;
	return TRUE;
}
